<?php
/*======================================================================*\
|| #################################################################### ||
|| # vBulletin
|| # ---------------------------------------------------------------- # ||
|| # All PHP code in this file is 2000-2008 Jelsoft Enterprises Ltd. # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- VBULLETIN IS NOT FREE SOFTWARE ---------------- # ||
|| # http://www.vbulletin.com | http://www.vbulletin.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/
/**
* vb_36_010 Import Phrase module
*
* @package			ImpEx.vb_36
* @version			$Revision: 1932 $
* @author			Jerry Hutchings <jerry.hutchings@vbulletin.com>
* @date				$Date: 2007-12-10 15:44:52 -0600 (Mon, 10 Dec 2007) $
* @copyright		http://www.vbulletin.com/license.html
*
*/
class vb_36_010 extends vb_36_000
{
	var $_dependent 	= '001';

	function vb_36_010(&$displayobject)
	{
		$this->_modulestring = $displayobject->phrases['import_phrase'];
	}

	function init(&$sessionobject, &$displayobject, &$Db_target, &$Db_source)
	{
		if ($this->check_order($sessionobject,$this->_dependent))
		{
			if ($this->_restart)
			{
				// TODO: The cleanout
				if ($this->restart($sessionobject, $displayobject, $Db_target, $Db_source,'clear_imported_phrases'))
				{
					$displayobject->display_now("<h4>{$displayobject->phrases['phrases_cleared']}</h4>");
					$this->_restart = true;
				}
				else
				{
					$sessionobject->add_error(substr(get_class($this) , -3), $displayobject->phrases['phrase_restart_failed'], $displayobject->phrases['check_db_permissions']);
				}
			}

			// Start up the table
			$displayobject->update_basic('title', $displayobject->phrases['import_phrase']);
			$displayobject->update_html($displayobject->do_form_header('index',substr(get_class($this) , -3)));
			$displayobject->update_html($displayobject->make_hidden_code(substr(get_class($this) , -3),'WORKING'));
			$displayobject->update_html($displayobject->make_table_header($this->_modulestring));

			// Ask some questions
			$displayobject->update_html($displayobject->make_input_code($displayobject->phrases['phrases_per_page'],'phraseperpage', 2000));

			// End the table
			$displayobject->update_html($displayobject->do_form_footer($displayobject->phrases['continue'],$displayobject->phrases['reset']));

			// Reset/Setup counters for this
			$sessionobject->add_session_var(substr(get_class($this) , -3) . '_objects_done', '0');
			$sessionobject->add_session_var(substr(get_class($this) , -3) . '_objects_failed', '0');
			$sessionobject->add_session_var('phrasestartat','0');
		}
		else
		{
			// Dependant has not been run
			$displayobject->update_html($displayobject->do_form_header('index',''));
			$displayobject->update_html($displayobject->make_description("<p>{$displayobject->phrases['dependant_on']}<i><b> " . $sessionobject->get_module_title($this->_dependent) . "</b> {$displayobject->phrases['cant_run']}</i> ."));
			$displayobject->update_html($displayobject->do_form_footer($displayobject->phrases['continue'],''));
			$sessionobject->set_session_var(substr(get_class($this) , -3),'FALSE');
			$sessionobject->set_session_var('module','000');
		}
	}


	function resume(&$sessionobject, &$displayobject, &$Db_target, &$Db_source)
	{
		// Set up working variables.
		$displayobject->update_basic('displaymodules','FALSE');
		$target_database_type	= $sessionobject->get_session_var('targetdatabasetype');
		$target_table_prefix	= $sessionobject->get_session_var('targettableprefix');
		$source_database_type	= $sessionobject->get_session_var('sourcedatabasetype');
		$source_table_prefix	= $sessionobject->get_session_var('sourcetableprefix');

		// Per page vars
		$phrase_start_at		= $sessionobject->get_session_var('phrasestartat');
		$phrase_per_page		= $sessionobject->get_session_var('phraseperpage');
		$class_num				= substr(get_class($this) , -3);

		// Start the timing
		if(!$sessionobject->get_session_var($class_num . '_start'))
		{
			$sessionobject->timing($class_num ,'start' ,$sessionobject->get_session_var('autosubmit'));
		}

		// Get an array of phrase details
		$phrase_array 	= $this->get_vb_36_phrase_details($Db_source, $source_database_type, $source_table_prefix, $phrase_start_at, $phrase_per_page);

		// Display count and pass time
		$displayobject->display_now("<h4>{$displayobject->phrases['importing']} " . count($phrase_array) . " {$displayobject->phrases['phrases']}</h4><p><b>{$displayobject->phrases['from']}</b> : " . $phrase_start_at . " ::  <b>{$displayobject->phrases['to']}</b> : " . ($phrase_start_at + count($phrase_array)) . "</p>");

		$phrase_object = new ImpExData($Db_target, $sessionobject, 'phrase');

		foreach ($phrase_array as $phrase_id => $details)
		{
			$try = (phpversion() < '5' ? $phrase_object : clone($phrase_object));

			$try->set_value('mandatory', 'importphraseid',	$phrase_id);
			$try->set_value('mandatory', 'varname',			$details['varname']);
			$try->set_value('mandatory', 'fieldname',		$details['fieldname']);
			$try->set_value('mandatory', 'text',			$details['text']);

			$try->set_value('nonmandatory', 'product',		$details['product']);
			$try->set_value('nonmandatory', 'languageid',	$details['languageid']);
			$try->set_value('nonmandatory', 'username',		$details['username']);
			$try->set_value('nonmandatory', 'dateline',		$details['dateline']);
			$try->set_value('nonmandatory', 'version',		$details['version']);

			// Check if phrase object is valid
			if($try->is_valid())
			{
				if($try->import_phrase($Db_target, $target_database_type, $target_table_prefix))
				{
					$displayobject->display_now('<br /><span class="isucc"><b>' . $try->how_complete() . ' %</b></span> ' . $displayobject->phrases['phrase'] . ' -> ' . $try->get_value('mandatory','varname'));
					$sessionobject->add_session_var($class_num . '_objects_done',intval($sessionobject->get_session_var($class_num . '_objects_done')) + 1 );
				}
				else
				{
					$sessionobject->set_session_var($class_num . '_objects_failed',$sessionobject->get_session_var($class_num. '_objects_failed') + 1 );
					$sessionobject->add_error($Db_target, 'warning', $class_num, $phrase_id, $displayobject->phrases['phrase_not_imported'] . ' : ' . $details['varname'] . ' : ' . $details['text'], $displayobject->phrases['phrase_not_imported_rem']);
					$displayobject->display_now("<br />{$displayobject->phrases['failed']} :: {$displayobject->phrases['phrase_not_imported']} " . $try->_failedon);
				}
			}
			else
			{
				$sessionobject->add_error($Db_target, 'invalid', $class_num, $phrase_id, $displayobject->phrases['invalid_object'], $try->_failedon);
				$displayobject->display_now("<br />{$displayobject->phrases['invalid_object']}" . $try->_failedon);
				$sessionobject->set_session_var($class_num . '_objects_failed',$sessionobject->get_session_var($class_num. '_objects_failed') + 1 );
			}
			unset($try);
		}// End foreach

		// Check for page end
		if (count($phrase_array) == 0 OR count($phrase_array) < $phrase_per_page)
		{
			$sessionobject->timing($class_num,'stop', $sessionobject->get_session_var('autosubmit'));
			$sessionobject->remove_session_var($class_num . '_start');

			$displayobject->update_html($displayobject->module_finished($this->_modulestring,
				$sessionobject->return_stats($class_num, '_time_taken'),
				$sessionobject->return_stats($class_num, '_objects_done'),
				$sessionobject->return_stats($class_num, '_objects_failed')
			));

			$sessionobject->set_session_var($class_num ,'FINISHED');
			$sessionobject->set_session_var('import_phrase','done');
			$sessionobject->set_session_var('module','000');
			$sessionobject->set_session_var('autosubmit','0');
		}

		$sessionobject->set_session_var('phrasestartat',$phrase_start_at+$phrase_per_page);
		$displayobject->update_html($displayobject->print_redirect('index.php',$sessionobject->get_session_var('pagespeed')));
	}// End resume
}//End Class
# Autogenerated on : August 9, 2006, 2:39 pm
# By ImpEx-generator 2.1.
/*======================================================================*\
|| ####################################################################
|| #
|| # CVS: $RCSfile$ - $Revision: 1932 $
|| ####################################################################
\*======================================================================*/
?>
